## musescore2 2.3.2%2Bdfsg4

=== mstyle/CMakeLists.txt ===
#=============================================================================
#  MusE
#  Linux Music Editor
#  $Id:$
#
#  Copyright (C) 2010 by Werner Schweer and others
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License version 2.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#=============================================================================

include (${PROJECT_SOURCE_DIR}/build/gch.cmake)

if (APPLE)
      file(GLOB_RECURSE INCS "*.h")
else (APPLE)
      set(INCS "")
endif (APPLE)

add_library (
      mstyle STATIC
      ${PROJECT_BINARY_DIR}/all.h
      ${PCH}
      ${INCS}
      mstyle.cpp colorscheme.cpp colorutils.cpp tileset.cpp stylehelper.cpp frameshadow.cpp
      animations.cpp animationdata.cpp dockseparatordata.cpp
      dockseparatorengine.cpp enabledata.cpp genericdata.cpp headerviewdata.cpp
      headerviewengine.cpp mdiwindowdata.cpp mdiwindowengine.cpp menubardata.cpp
      menubarengine.cpp menuengine.cpp progressbardata.cpp
      progressbarengine.cpp scrollbardata.cpp scrollbarengine.cpp sliderdata.cpp
      sliderengine.cpp spinboxdata.cpp spinboxengine.cpp splitterengine.cpp
      tabbardata.cpp tabbarengine.cpp toolbardata.cpp toolbarengine.cpp
      toolboxengine.cpp widgetstatedata.cpp widgetstateengine.cpp mconfig.cpp
      comboboxdata.cpp comboboxengine.cpp labeldata.cpp labelengine.cpp lineeditdata.cpp
      lineeditengine.cpp stackedwidgetdata.cpp stackedwidgetengine.cpp transitiondata.cpp
      transitions.cpp transitionwidget.cpp
      baseengine.h menudata.h animation.h
      )

set_target_properties (
      mstyle
      PROPERTIES
         COMPILE_FLAGS "${PCH_INCLUDE} -g -Wall -Wextra -Winvalid-pch"
      )

xcode_pch(mstyle all)

ADD_DEPENDENCIES(mstyle mops1)
ADD_DEPENDENCIES(mstyle mops2)

=== mtest/CMakeLists.txt ===
#=============================================================================
#  MuseScore
#  Music Composition & Notation
#  $Id:$
#
#  Copyright (C) 2011-2013 Werner Schweer
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License version 2
#  as published by the Free Software Foundation and appearing in
#  the file LICENSE.GPL
#=============================================================================

# set(CMAKE_VERBOSE_MAKEFILE ON)
enable_testing()

include_directories(
      ${PROJECT_BINARY_DIR}
      ${PROJECT_SOURCE_DIR}
      ${PROJECT_SOURCE_DIR}/thirdparty/freetype/include
      )

if (OMR)
set(OMR_SRC ${PROJECT_SOURCE_DIR}/omr/importpdf.cpp)
endif (OMR)

QT5_ADD_RESOURCES(qrc_files ${PROJECT_SOURCE_DIR}/mtest/mtest.qrc
            ${PROJECT_SOURCE_DIR}/mscore/musescorefonts-MScore.qrc
            ${PROJECT_SOURCE_DIR}/mscore/musescorefonts-Gootville.qrc
            ${PROJECT_SOURCE_DIR}/mscore/musescorefonts-Bravura.qrc
            ${PROJECT_SOURCE_DIR}/mscore/musescorefonts-MuseJazz.qrc
            ${PROJECT_SOURCE_DIR}/mscore/musescorefonts-Free.qrc
            ${PROJECT_SOURCE_DIR}/mscore/musescorefonts-FreeSerif.qrc
      )

add_library (testResources STATIC
      ${qrc_files}
      )

add_library(
      testutils STATIC
      testutils.cpp
      ${PROJECT_SOURCE_DIR}/libmscore/mcursor.cpp
      ${PROJECT_SOURCE_DIR}/mscore/album.cpp
      ${PROJECT_SOURCE_DIR}/mscore/bb.cpp
      ${PROJECT_SOURCE_DIR}/mscore/capella.cpp
      ${PROJECT_SOURCE_DIR}/mscore/capxml.cpp
      ${PROJECT_SOURCE_DIR}/mscore/exportxml.cpp
      ${PROJECT_SOURCE_DIR}/mscore/importgtp.cpp
      ${PROJECT_SOURCE_DIR}/mscore/importgtp-gp4.cpp
      ${PROJECT_SOURCE_DIR}/mscore/importgtp-gp5.cpp
      ${PROJECT_SOURCE_DIR}/mscore/importgtp-gp6.cpp
      ${PROJECT_SOURCE_DIR}/mscore/importove.cpp
      ${PROJECT_SOURCE_DIR}/mscore/ove.cpp
      ${PROJECT_SOURCE_DIR}/mscore/importmidi/importmidi.cpp
      ${PROJECT_SOURCE_DIR}/mscore/importmidi/importmidi_operations.cpp
      ${PROJECT_SOURCE_DIR}/mscore/importmidi/importmidi_meter.cpp
      ${PROJECT_SOURCE_DIR}/mscore/importmidi/importmidi_quant.cpp
      ${PROJECT_SOURCE_DIR}/mscore/importmidi/importmidi_tuplet.cpp
      ${PROJECT_SOURCE_DIR}/mscore/importmidi/importmidi_tuplet_detect.cpp
      ${PROJECT_SOURCE_DIR}/mscore/importmidi/importmidi_tuplet_filter.cpp
      ${PROJECT_SOURCE_DIR}/mscore/importmidi/importmidi_tuplet_voice.cpp
      ${PROJECT_SOURCE_DIR}/mscore/importmidi/importmidi_tuplet_tonotes.cpp
      ${PROJECT_SOURCE_DIR}/mscore/importmidi/importmidi_chord.cpp
      ${PROJECT_SOURCE_DIR}/mscore/importmidi/importmidi_fraction.cpp
      ${PROJECT_SOURCE_DIR}/mscore/importmidi/importmidi_swing.cpp
      ${PROJECT_SOURCE_DIR}/mscore/importmidi/importmidi_drum.cpp
      ${PROJECT_SOURCE_DIR}/mscore/importmidi/importmidi_clef.cpp
      ${PROJECT_SOURCE_DIR}/mscore/importmidi/importmidi_lrhand.cpp
      ${PROJECT_SOURCE_DIR}/mscore/importmidi/importmidi_lyrics.cpp
      ${PROJECT_SOURCE_DIR}/mscore/importmidi/importmidi_tie.cpp
      ${PROJECT_SOURCE_DIR}/mscore/importmidi/importmidi_inner.cpp
      ${PROJECT_SOURCE_DIR}/mscore/importmidi/importmidi_beat.cpp
      ${PROJECT_SOURCE_DIR}/mscore/importmidi/importmidi_simplify.cpp
      ${PROJECT_SOURCE_DIR}/mscore/importmidi/importmidi_voice.cpp
      ${PROJECT_SOURCE_DIR}/mscore/importmidi/importmidi_key.cpp
      ${PROJECT_SOURCE_DIR}/mscore/importmidi/importmidi_tempo.cpp
      ${PROJECT_SOURCE_DIR}/mscore/importmidi/importmidi_model.cpp
      ${PROJECT_SOURCE_DIR}/mscore/importmidi/importmidi_instrument.cpp
      ${PROJECT_SOURCE_DIR}/mscore/importmidi/importmidi_chordname.cpp
      ${PROJECT_SOURCE_DIR}/mscore/exportmidi.cpp
      ${PROJECT_SOURCE_DIR}/mscore/importmxml.cpp               # Required by importxml.cpp
      ${PROJECT_SOURCE_DIR}/mscore/importmxmllogger.cpp         # Required by importxml.cpp
      ${PROJECT_SOURCE_DIR}/mscore/importmxmlnoteduration.cpp   # Required by importxml.cpp
      ${PROJECT_SOURCE_DIR}/mscore/importmxmlnotepitch.cpp      # Required by importxml.cpp
      ${PROJECT_SOURCE_DIR}/mscore/importmxmlpass1.cpp          # Required by importxml.cpp
      ${PROJECT_SOURCE_DIR}/mscore/importmxmlpass2.cpp          # Required by importxml.cpp
      ${PROJECT_SOURCE_DIR}/mscore/importxml.cpp
      ${PROJECT_SOURCE_DIR}/mscore/importxmlfirstpass.cpp
      ${PROJECT_SOURCE_DIR}/mscore/musicxmlfonthandler.cpp
      ${PROJECT_SOURCE_DIR}/mscore/musicxmlsupport.cpp
      ${PROJECT_SOURCE_DIR}/mscore/qmlplugin.cpp
      ${PROJECT_SOURCE_DIR}/mscore/shortcut.cpp
      ${PROJECT_SOURCE_DIR}/thirdparty/rtf2html/fmt_opts.cpp    # required by capella.cpp and capxml.cpp
      ${PROJECT_SOURCE_DIR}/thirdparty/rtf2html/rtf2html.cpp    # required by capella.cpp and capxml.cpp
      ${PROJECT_SOURCE_DIR}/thirdparty/rtf2html/rtf_keyword.cpp # required by capella.cpp and capxml.cpp
      ${PROJECT_SOURCE_DIR}/thirdparty/rtf2html/rtf_table.cpp   # required by capella.cpp and capxml.cpp
      ${PROJECT_SOURCE_DIR}/thirdparty/beatroot/Agent.cpp           # required by importmidi.cpp
      ${PROJECT_SOURCE_DIR}/thirdparty/beatroot/AgentList.cpp       # required by importmidi.cpp
      ${PROJECT_SOURCE_DIR}/thirdparty/beatroot/BeatTracker.cpp     # required by importmidi.cpp
      ${PROJECT_SOURCE_DIR}/thirdparty/beatroot/Induction.cpp       # required by importmidi.cpp
      ${PROJECT_SOURCE_DIR}/mscore/stringutils.cpp
      ${PROJECT_SOURCE_DIR}/mscore/extension.cpp # required by zerberus tests
      ${OMR_SRC}
      omr
      )

add_executable(
      mtest
      mtest.cpp
      )

target_link_libraries(
      mtest
      ${QT_LIBRARIES}
      mscore_freetype
      )

set(CMAKE_CXX_FLAGS         "${CMAKE_CXX_FLAGS} ${Qt5Widgets_EXECUTABLE_COMPILE_FLAGS}")

string(REPLACE ";" ";-I" INC "${QT_INCLUDES}")

if (APPLE AND (CMAKE_VERSION VERSION_LESS "3.5.0"))
set_target_properties (
      testutils
      PROPERTIES
      COMPILE_FLAGS "-include all.h -D TESTROOT=\\\\\"${PROJECT_SOURCE_DIR}\\\\\" -g -Wall -Wextra"
      )
else (APPLE AND (CMAKE_VERSION VERSION_LESS "3.5.0"))
set_target_properties (
      testutils
      PROPERTIES
      COMPILE_FLAGS "-include all.h -D TESTROOT=\\\"${PROJECT_SOURCE_DIR}\\\" -g -Wall -Wextra"
      )
endif (APPLE AND (CMAKE_VERSION VERSION_LESS "3.5.0"))

#      COMPILE_FLAGS "-include all.h -I ${INC} -D TESTROOT=\\\"${PROJECT_SOURCE_DIR}\\\" -g -Wall -Wextra"

add_custom_target(report
      COMMAND ant -f ${PROJECT_SOURCE_DIR}/mtest/build.xml -Droot.dir=${PROJECT_BINARY_DIR}/mtest report
      WORKING_DIRECTORY "${PROJECT_BINARY_DIR}/mtest"
      )

add_custom_target(reporthtml
      COMMAND ant -f ${PROJECT_SOURCE_DIR}/mtest/build.xml -Droot.dir=${PROJECT_BINARY_DIR}/mtest reporthtml
      WORKING_DIRECTORY "${PROJECT_BINARY_DIR}/mtest"
      )

subdirs (libmscore importmidi capella biab musicxml guitarpro scripting testoves zerberus stringutils)

install(FILES
      ../share/styles/chords_std.xml
      ../share/styles/chords_jazz.xml
      ../share/styles/chords.xml
      ../share/styles/stdchords.xml
      ../share/styles/jazzchords.xml
      ../share/styles/cchords_muse.xml
      ../share/styles/cchords_nrb.xml
      ../share/styles/cchords_rb.xml
      ../share/styles/cchords_sym.xml
      DESTINATION ${PROJECT_BINARY_DIR}/mtest/styles
      )


if (OMR)
subdirs(omr)
endif (OMR)

=== mtest/importmidi/CMakeLists.txt ===
#=============================================================================
#  MuseScore
#  Music Composition & Notation
#  $Id:$
#
#  Copyright (C) 2011 Werner Schweer
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License version 2
#  as published by the Free Software Foundation and appearing in
#  the file LICENSE.GPL
#=============================================================================

set(TARGET tst_importmidi)

include(${PROJECT_SOURCE_DIR}/mtest/cmake.inc)

=== mtest/libmscore/barline/CMakeLists.txt ===
#=============================================================================
#  MuseScore
#  Music Composition & Notation
#
#  Copyright (C) 2011 Werner Schweer
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License version 2
#  as published by the Free Software Foundation and appearing in
#  the file LICENSE.GPL
#=============================================================================

set(TARGET tst_barline)

include(${PROJECT_SOURCE_DIR}/mtest/cmake.inc)

=== mtest/libmscore/concertpitch/CMakeLists.txt ===
#=============================================================================
#  MuseScore
#  Music Composition & Notation
#  $Id:$
#
#  Copyright (C) 2011 Werner Schweer
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License version 2
#  as published by the Free Software Foundation and appearing in
#  the file LICENSE.GPL
#=============================================================================

set(TARGET tst_concertpitchbenchmark)

include(${PROJECT_SOURCE_DIR}/mtest/cmake.inc)

=== mtest/libmscore/cursor/CMakeLists.txt ===
#=============================================================================
#  MuseScore
#  Music Composition & Notation
#  $Id:$
#
#  Copyright (C) 2011 Werner Schweer
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License version 2
#  as published by the Free Software Foundation and appearing in
#  the file LICENSE.GPL
#=============================================================================

set(TARGET tst_cursor)

include(${PROJECT_SOURCE_DIR}/mtest/cmake.inc)

=== debian/watch ===
# debian/watch - check for a new upstream release and fetch it. See USCAN(1).
# The script 'debian/repack' is called to perform changes for DFSG compliance.
# Since repacking is used, do not add --rename when invoking uscan, please.
version=4
opts=\
uversionmangle=s/%25/~/,\
dversionmangle=s/\+dfsg\d*$//,\
repack,\
repacksuffix=+dfsg4,\
compression=gz,\
searchmode=plain,\
filenamemangle=s/.+\/v?([0-9]+\.[0-9](?:[0-9.]*(?:%25pre)?[0-9]+)?)/MuseScore-$1.tar.gz/ \
  https://api.github.com/repos/musescore/MuseScore/tags?per_page=200 \
  https:[^"]*/tarball/v?(2\.[0-9](?:[0-9.]*(?:%25pre)?[0-9]+)?)(?="|$) \
debian debian/repack

## musescore2 2.3.2+dfsg3

=== debian/changelog ===
musescore2 (2.3.2+dfsg3-11~bpo9+1) stretch-backports-sloppy; urgency=high

  * Rebuild for stretch-backports-sloppy.
  * Remaining changes against buster-backports:
    - Revert to debhelper 12 << 12.9~
    - Drop R³:no for backports
    - VCS-* branch adjustment

 -- Thorsten Glaser <tg@mirbsd.de>  Fri, 30 Oct 2020 07:42:03 +0100

musescore2 (2.3.2+dfsg3-11~bpo10+1) buster-backports; urgency=high

  * Rebuild for buster-backports.
  * Adjust VCS-* headers
  * Readd -Wl,--as-needed for buster

 -- Thorsten Glaser <tg@mirbsd.de>  Fri, 30 Oct 2020 07:38:30 +0100

musescore2 (2.3.2+dfsg3-11) unstable; urgency=medium

  * Update lintian overrides
  * Fix copypasta in copyright file
  * Merge improvements from upstream or submitted:
    - regenerate libmscore/sym.* from SMuFL metadata, here Bravura
    - indicate also the on/off time and pitch offset (tuning) in the
      status line; spell octave in B♯ and C♭ correctly while at it
    - fix rendering of parenthesised accidentals
    - place lyrics hyphens at a maxumum 5 sp distance
    - fix AppData
    - improve MScore accidentals
  * Update patch metadata

 -- Thorsten Glaser <tg@mirbsd.de>  Thu, 29 Oct 2020 10:37:34 +0100

musescore2 (2.3.2+dfsg3-10) unstable; urgency=low

  * Force timezone to UTC during build: cmake creating PKZIP
    archives inserts the MS-DOS timestamp, which is localtime
  * Source upload after NEW pass

 -- Thorsten Glaser <tg@mirbsd.de>  Thu, 06 Aug 2020 14:42:47 +0200

musescore2 (2.3.2+dfsg3-9) unstable; urgency=medium

  * Quieten another G++ warning that’s upstream’s job
  * Fix SMuFL typo
  * Apply some upstream/backported patches:
    - Synthesiser: char vs signed char mismatch
    - crash on drag/drop
    - insertStaff: set idx, so spacer down works
    - erasing a HBox crashed
    - crash when changing a triplet’s rest’s duration
    - Pianoroll: don’t store redundant/default values in XML
    - ottava font too big
    - fix pitch and accidental line used for ottavas
    - Preferences: radio buttons for sound in dialogue
    - bad octave for B♯ and C♭
    - crash on selecting a font
    - Desktop file: StartupWMClass to allow icon grouping
  * Reintroduce to Debian: it’s become clear that upstream expects
    users to keep the old version installed in parallel with the
    new version because the new one wrecks layout in files laid out
    by the old version and maintenance turns out to be less burden
    than initially expected
  * Document the situation with musescore{,3,4} in Description
  * Provides: musescore2 (for consistency)

 -- Thorsten Glaser <tg@mirbsd.de>  Thu, 30 Jul 2020 23:56:36 +0200

musescore2 (2.3.2+dfsg3-8) wtf; urgency=low

  * Bump Policy (nothing relevant), debhelper
  * Remove dependencies on Qt SQL library which are unneeded
  * Fix DEP 5 format: repacking notice must be in Source, not a Comment
  * Update patches (forwarding information / releases fixed)
  * Drop home-grown umask fixup code, dh does this nowadays
  * Use dh’s new execute_{before,after}_* overrides
  * Work around #796257 to fix Debian reproducible builds
  * Don’t show irrelevant Qt5 deprecation warnings; upstream’s to fix
  * Forward and apply fixes by lintian

 -- Thorsten Glaser <tg@mirbsd.de>  Sun, 12 Jul 2020 17:34:13 +0200

musescore2 (2.3.2+dfsg3-7) wtf; urgency=low

  * Add some more (minor) upstream patches
  * Apply workaround for broken directory bookmarks in file dialogue
  * Use the Debian freefont packaging instead of bundling it
  * Drop false positive from lintian overrides as it’s gone
  * Add Depends, Recommends to B-D, so uninstallability is noticed
  * Lower pulseaudio-utils to merely Suggests

 -- Thorsten Glaser <tg@mirbsd.de>  Sun, 10 Nov 2019 22:24:16 +0100

musescore2 (2.3.2+dfsg3-6) wtf; urgency=low

  * d/copyright: Update MuseJazz information from historic records
  * d/copyright: Write year numbers consistently (four digits, comma)
  * Set umask 022 for reproducibility
  * Improve/fix packaging, from MagicPoint
  * Run the tests in an UTF-8 locale
  * Pass -g3 in addition to -Og for “optdbg” builds
  * Use /usr/share/dpkg/buildtools.mk (for cross build) only if extant
  * Policy 4.4.1 (no change needed)

 -- Thorsten Glaser <tg@mirbsd.de>  Sun, 29 Sep 2019 21:58:54 +0200

musescore2 (2.3.2+dfsg3-5) wtf; urgency=low

  * Create system soundfont directories in maintainer scripts,
    so adequate does not warn and the local admin will know
    where system-wide soundfonts are installed
  * Policy 4.4.0.0 from d-d-a (grudgingly though this uses dh7-style)
  * d/u/metadata: update Donation information from upstream
  * Finish castling: master now carries MuseScore 3.x in bullseye/sid
  * d/rules: make some paths that differ between branches into variables
  * Reduce d/rules diff against master
  * d/musescore-common.NEWS: drop
  * d/control: Add default soundfont setup command to long description

 -- Thorsten Glaser <tg@mirbsd.de>  Wed, 10 Jul 2019 01:14:58 +0200

musescore2 (2.3.2+dfsg3-4) wtf; urgency=low

  * Update UMEGAYA (DEP 12) Changelog link
  * Merge musescore (2.3.2+dfsg2-8) unstable; urgency=low

 -- Thorsten Glaser <tg@mirbsd.de>  Thu, 04 Jul 2019 19:37:27 +0200

musescore2 (2.3.2+dfsg3-3) wtf; urgency=high

  * Merge musescore (2.3.2+dfsg2-7) unstable; urgency=high
  * Display distro packaging versioning in About, --long-version

 -- Thorsten Glaser <tg@mirbsd.de>  Tue, 02 Jul 2019 23:18:37 +0200

musescore2 (2.3.2+dfsg3-2) wtf; urgency=medium

  * Log prevented note collisions in revert-restriking patch
  * debian/buildtest: move nocheck test here
  * Streamline and (slightly) optimise debian/rules
  * Build under the C.UTF-8 locale
  * Add patch to show two pitches (in transposing mode) in status line
  * Pull upstream commit to fix barbeat counting from 3.1

 -- Thorsten Glaser <tg@mirbsd.de>  Mon, 03 Jun 2019 18:06:02 +0200

musescore2 (2.3.2+dfsg3-1) wtf; urgency=low

  * Renamed source package, to complete castling (src:musescore builds


=== debian/control ===
Source: musescore2
Section: sound
Priority: optional
Maintainer: Thorsten Glaser <tg@mirbsd.de>
Homepage: https://musescore.org/en
Build-Depends: debhelper-compat (= 12),
# # for the tests
# imagemagick,
  mksh,
  xauth,
  xvfb,
# # testsuite and runtime
  desktop-file-utils,
  fonts-freefont-ttf,
  libmp3lame0,
  musescore-general-soundfont-small | musescore-compatible-soundfont,
  qml-module-qtquick-controls,
  qml-module-qtquick-dialogs,
  qml-module-qtquick-layouts,
  qml-module-qtquick2,
  shared-mime-info,
  xdg-utils,
# # build
  cmake,
  g++ (>= 4:4.8),
  libasound2-dev,
  libfreetype6-dev (>= 2.5.2),
  libjack-dev,
  libmp3lame-dev,
  libportmidi-dev [linux-any],
  libpulse-dev,
  libqt5opengl5-dev,
  libqt5svg5-dev,
  libqt5xmlpatterns5-dev,
  libsndfile1-dev (>= 1.0.25),
  lsb-release,
  portaudio19-dev,
  qtbase5-dev,
  qtdeclarative5-dev (>= 5.4),
  qtscript5-dev,
  qttools5-dev,
  qttools5-dev-tools,
  zlib1g-dev
Standards-Version: 4.5.0
#Rules-Requires-Root: no
VCS-git: https://evolvis.org/anonscm/git/alioth/musescore.git -b stretch-backports
VCS-Browser: https://evolvis.org/plugins/scmgit/cgi-bin/gitweb.cgi?p=alioth/musescore.git;a=shortlog;h=refs/heads/stretch-backports

Package: musescore-common
Architecture: all
Multi-Arch: foreign
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
 musescore-general-soundfont-small | musescore-compatible-soundfont
Description: MuseScore 2 (music composition and notation) shared files
 Demonstration scores and templates, styles, localisations, some
 plugins for MuseScore, the Open Source (GNU GPL) cross-platform
 multi-lingual music notation software.
 .
 In contrast to earlier versions, no sound font is provided by
 default, but the Depends ensure a suitable one is installed,
 normally the compact, full orchestral and band sound, one that
 is shipped with MuseScore from version 2.2 onwards, or its more
 limited 2.1 counterpart fluidr3mono-gm-soundfont. In general,
 any soundfont that Provides musescore-compatible-soundfont will
 be acceptable; if you installed multiple, run the following
 command to configure the default MuseScore soundfont (select
 “0” to ensure that the highest-quality soundfont is used):
 .
 $ sudo update-alternatives --config MuseScore_General.sf3

Package: musescore
Provides: musescore2
Architecture: any
Multi-Arch: foreign
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends},
  desktop-file-utils,
  fonts-freefont-ttf,
  qml-module-qtquick-controls,
  qml-module-qtquick-dialogs,
  qml-module-qtquick-layouts,
  qml-module-qtquick2,
  shared-mime-info,
  xdg-utils,
# # dependent on MSCORE_INSTALL_SUFFIX from debian/rules
# # and MUSESCORE_VERSION_{MAJOR,MINOR} from CMakeLists.txt
  musescore-common (>> 2.3~), musescore-common (<< 2.4~)
Recommends: libmp3lame0
Suggests: pulseaudio-utils
Description: cross-platform multi-lingual music composition and notation, v2
 MuseScore is an Open Source (GNU GPL) music notation software that runs
 on all platforms supported by Qt5 (GNU/Linux, MacOS X, Windows), and is
 available in over forty different languages. It features an easy to use
 WYSIWYG editor with audio score playback for results that look and sound
 beautiful, rivaling commercial offerings like Finale and Sibelius.
 .
 This package provides MuseScore 2. You can install multiple versions of
 MuseScore in parallel, and upstream recommends doing so, because each
 major version has a new, incompatible, layout engine, and changing old
 scores without relayouting them fully with the new version can only be
 done by the old version. Install the musescore3 package for MuseScore 3
 and expect a musescore4 package to show up in Debian bookworm.
 .
 Create, play back and print sheet music for free. Features include:
  - easy-to-use and customisable interface
  - albums combining multiple scores
  - unlimited score length
  - unlimited number of staves per system
  - up to four independent voices per staff
  - score creation wizard and templates
  - easy and fast note entry with a (PC) keyboard, the mouse, including
    an on-screen virtual (piano) keyboard, or MIDI (step-time, real-time)
  - continuous view: focus on the content, scrolling by as an endless
    ribbon, undistracted by line breaks or page breaks; switch to page
    view to polish up for printing
  - automatic part extraction and transposition; advanced transposition:
    transpose a selected passage to any key, or by any interval — or
    even transpose diatonically within the same key
  - repeats, including segnos, codas, measure repeats, advanced repeats
  - dynamics, articulations and other expression markings
  - playback support for almost all notation elements
  - custom text markings
  - style rules that apply to the whole score at once
  - lyrics
  - chord symbols
  - Jazz notation, including lead sheets and slash notation
  - swing and shuffle playback
  - integrated sequencer and two software synthesisers (FluidSynth for
    SF2/SF3, Zerberus for SFZ), which also can use third-party soundfonts
  - mixer for instrument levels and effects
  - mixing and panning for individual parts
  - percussion notation
  - early music notation
  - cross-staff beaming
  - import of graphics
  - custom key signatures
  - additive time signatures
  - user-defined score styles
  - and much more…
 .
 Choir features:
  - powerful lyrics copy and paste tools
  - implode/explode: combine up to four voices on one staff,
    then separate to individual staves
  - hide empty vocal staves, such as in a piano intro
  - figured bass for historical notation
  - smart lyrics: unlimited verses, with notes and staves automatically
    spaced, and verse numbers automatically aligned
  - voice leading checker: download the Check Harmony Rules proofreading
    plugin to check for errors in your part writing, according to
    standard rules
  - part mixer: mute, solo, or change volume of staves to learn
    individual lines — settings even apply to MP3 export
 .
 Piano features:
  - support for solo + piano (add small staff with different instrument)
  - support for cadenzas (smaller notes and variable length measures)
  - complete notation: pedaling, fingering, cross-staff beaming — you
    name it; everything needed to write piano sheet music is here
 .
 Guitar features:
  - bends, fingerings, and other common guitar notations supported
  - add/remove linked staves any time; enter notes on either standard
    (pitched five-line) or TAB staff
  - percussion/drumset also included
  - templates include guitar, tablature, guitar+tablature, rock/pop band
  - complete tablature: multiple tab styles available — from note symbols
    outside the staff to upside-down strings — and linked standard/tab
    staff pairs
  - Guitar Pro import: MuseScore can now open files from Guitar Pro, so
    you can easily migrate over. Import filters are improving with every
    release; GP3, GP4, GP5, GP6, GTP, GPX are currently supported.
  - Fretboard diagrams: 21 default chords for every key, and a powerful
    editor to create your own — with barre, fret position, and any number
    of strings
  - beyond guitar: banjo, mandolin, ukulele, oud; custom string tunings;
    even historical lute tablature: MuseScore does them all.
 .
 Orchestral features:
  - templates for common instrumentations
  - custom linked parts (e.g. create choral score from orchestra+chorus):
    any change you make to the content of any part is immediately
    reflected in the full score — and vice versa
  - powerful style controls: edit the formatting of parts and score
    independently — or apply the same style to all parts with one click
  - one-click transposition: instantly switch between transposed and
    concert pitch: sounding pitches stay the same while the written notes
    change
 .
 Jazz features:
  - templates for Jazz Lead Sheet, Big Band and Jazz Combo
  - real “handwritten” Book-style jazz font for text and chord symbols
  - formatting tools include adding line breaks every X measures
  - instantly switch between transposed and concert pitch
  - intelligent chord symbol: chord names are automatically formatted
    when you finish typing — plus, they transpose with the notes
  - easy slashes: commands to fill bars with slashes — and to turn notes
    into rhythmic slashes, and even accent notation above the staff
 .
 Marching ensembles features (needs the MDL extension):
  - marching band, indoor percussion, front ensemble, drumline and drum
    corps (even G bugles); no setup or configuration — select a template,
    start writing
 .
 Band features:
  - diverse templates: concert band, brass band, marching band, battery
    and pit percussion — ready out-of-the-box (plus big band for jazz)
  - custom linked parts: you can even keep a drumline score linked to a
    full marching band score and to individual percussion parts
 .
 Most elements in MuseScore are laid out automatically on a “virtual note
 sheet”, with a near professional-quality layout engine, but can also be
 positioned manually, giving you total control of every score element’s
 position. The capabilities of MuseScore can be extended via plugins and
 extensions, and the growing repository on musescore.org contains many
 plugins submitted by users and an active development team.
 .
 MuseScore includes a set of sounds that reproduce common instruments (as
 defined by General MIDI) without taking up a lot of disk space or memory
 providing full orchestral and band sounds (with the Drumline extension
 installed this includes marching percussion). The general (non-Drumline)
 sound font is available as musescore-general-soundfont Debian package,
 if you wish to reuse it with other synthesisers.) You can also load any
 sound font you prefer for a wider variety of sounds or for more realism.
 .
 MuseScore can import and export MIDI and MusicXML files, and it can also
 import from Capella and several other programs. MuseScore can export to
 PDF, PNG, and other graphic formats, to WAV and other audio formats such
 as OGG Vorbis and MP3, or to GNU Lilypond for an alternative layout and
 print option.
 .
 MuseScore can upload scores to musescore.com, a score sharing site, and
 send scrolling sheet music videos to YouTube. In addition to the desktop
 software, you can rehearse “on the go” with MuseScore mobile apps (which
 do not support note entry, but many advanced playback functions). Note
 that all of these are commercial or otherwise non-free offers optionally
 integrated with, but not part of, the Free notation program. Scrolling
 video scores feature the notes highlighted in the score as they sound —
 and highlighted on a virtual piano keyboard below.

=== debian/rules ===
#!/usr/bin/make -f

CWD:=$(abspath .)

ifeq (,$(filter terse,${DEB_BUILD_OPTIONS}))
export DH_VERBOSE=1
export V=1
export VERBOSE=1
endif

LC_ALL:=C.UTF-8
export LC_ALL
TZ:=UTC
export TZ

shellescape='$(subst ','\'',$(1))'
shellexport=$(1)=$(call shellescape,${$(1)})

MSPPKG=musescore
MSCPKG=${MSPPKG}-common
MSPDIR=debian/${MSPPKG}
MSCDIR=debian/${MSCPKG}
MSHARE=usr/share/mscore-*

DEB_HOST_ARCH?=$(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_ARCH_OS?=$(shell dpkg-architecture -qDEB_HOST_ARCH_OS)

OUR_CPPFLAGS:=
OUR_CFLAGS:=
OUR_CXXFLAGS:=
OUR_LDFLAGS:=

# unclutter build log; these are upstream’s to fix
OUR_CPPFLAGS+=	-Wno-deprecated-declarations
OUR_CPPFLAGS+=	-Wno-deprecated-copy

# only needed when backporting to buster and older
OUR_LDFLAGS+=	-Wl,--as-needed

# defined for most of the code anyway; doing this here helps the PCH
OUR_CPPFLAGS+=	-DQT_NO_DEBUG
# avoid stray debugging output
OUR_CPPFLAGS+=	-DNDEBUG
# disable phoning home
OUR_CPPFLAGS+=	-DMSCORE_NO_UPDATE_CHECKER

# better debugging if requested
ifneq (,$(findstring optdbg,${DEB_BUILD_OPTIONS}))
OUR_CFLAGS+=	-Og -g3
OUR_CXXFLAGS+=	-Og -g3
endif

# things that cannot be passed via CPPFLAGS
OUR_CPPFLAGS+=	-I${CWD}/debian/q-include

dpkgbuildflagsmkescape=$(subst \,\\\,$(1))
export DEB_BUILD_MAINT_OPTIONS:=hardening=+all
export DEB_CPPFLAGS_MAINT_APPEND:=$(call dpkgbuildflagsmkescape,${OUR_CPPFLAGS})
export DEB_CFLAGS_MAINT_APPEND:=$(call dpkgbuildflagsmkescape,${OUR_CFLAGS})
export DEB_CXXFLAGS_MAINT_APPEND:=$(call dpkgbuildflagsmkescape,${OUR_CXXFLAGS})
export DEB_LDFLAGS_MAINT_APPEND:=$(call dpkgbuildflagsmkescape,${OUR_LDFLAGS})
include /usr/share/dpkg/buildflags.mk
ifneq (,$(wildcard /usr/share/dpkg/buildtools.mk))
include /usr/share/dpkg/buildtools.mk
endif
include /usr/share/dpkg/pkg-info.mk

%:
	dh $@ --buildsystem=cmake

CMAKE_DEFS:=	-DCMAKE_SKIP_RPATH=ON
CMAKE_DEFS+=	-DDOWNLOAD_SOUNDFONT=OFF
CMAKE_DEFS+=	-DUSE_SYSTEM_FREETYPE=ON \
		-DFREETYPE_INCLUDE_DIRS=/usr/include/freetype2/
CMAKE_DEFS+=	-DBUILD_WEBKIT=OFF

ifneq (linux,${DEB_HOST_ARCH_OS})
CMAKE_DEFS+=	-DBUILD_PORTMIDI=OFF
endif

override_dh_auto_configure:
	test -s fonts/mscore/mscore.old || \
	    mv fonts/mscore/mscore.ttf fonts/mscore/mscore.old
	cp -f debian/upstream/mscore.ttf fonts/mscore/mscore.ttf
	rm -rf debian/q-include
	mkdir debian/q-include
	printf '#define DEB_PKG_VERSION "%s (%s %s/%s)"\n' \
	    $(call shellescape,${DEB_VERSION}) \
	    "$$(lsb_release -si)" \
	    "$$(lsb_release -sc)" \
	    $(call shellescape,${DEB_HOST_ARCH}) \
	    >debian/q-include/DEB_PKG_VERSION.h
	exec dh_auto_configure -- ${CMAKE_DEFS}

override_dh_auto_build:
	env GNUMAKEFLAGS="$$GNUMAKEFLAGS --output-sync" \
	    dh_auto_build -- lrelease all

override_dh_auto_test:
	exec mksh debian/buildtest ${DEB_BUILD_OPTIONS}

override_dh_install-indep:
	# move stuff to packages
	dh_install
	# make system-wide soundfonts available
	cd ${MSCDIR}/${MSHARE} && mkdir -p sound && \
	    ln -sf ../../sounds/sf2 ../../sounds/sf3 ../../sounds/sfz sound/

override_dh_auto_clean:
	dh_auto_clean
	test '!' -s fonts/mscore/mscore.old || \
	    mv -f fonts/mscore/mscore.old fonts/mscore/mscore.ttf
	rm -rf debian/q-include
	-chmod -R g-w . # work around #796257 for Debian reproducible-builds

=== debian/watch ===
# debian/watch - check for a new upstream release and fetch it. See USCAN(1).
# The script 'debian/repack' is called to perform changes for DFSG compliance.
version=4
opts=\
uversionmangle=s/%25/~/,\
dversionmangle=s/\+dfsg\d*$//,\
repacksuffix=+dfsg3,\
compression=gz,\
filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/MuseScore-$1\.tar\.gz/ \
  https://github.com/musescore/MuseScore/tags .*/v?(2.[0-9](?:[0-9.]*(?:%25pre)?[0-9]+)?)\.tar\.gz \
debian debian/repack
